/*
**  ASTq -- Abstract Syntax Tree (AST) Query Engine
**  Copyright (c) 2014-2015 Ralf S. Engelschall <rse@engelschall.com>
**
**  Permission is hereby granted, free of charge, to any person obtaining
**  a copy of this software and associated documentation files (the
**  "Software"), to deal in the Software without restriction, including
**  without limitation the rights to use, copy, modify, merge, publish,
**  distribute, sublicense, and/or sell copies of the Software, and to
**  permit persons to whom the Software is furnished to do so, subject to
**  the following conditions:
**
**  The above copyright notice and this permission notice shall be included
**  in all copies or substantial portions of the Software.
**
**  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
**  EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
**  MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
**  IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
**  CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
**  TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
**  SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
*/

let ASTQAdapterXMLDOM = {
    taste (node) {
        /* global Node: true */
        return (
               typeof Node === "object"
            && node instanceof Node
            && typeof node === "object"
            && typeof node.nodeType === "number"
            && typeof node.nodeName === "string"
        )
    },
    getParentNode (node) {
        return node.parentNode
    },
    getChildNodes (node) {
        return node.childNodes
    },
    getNodeType (node) {
        return node.nodeName
    },
    getNodeAttrNames (node) {
        return Array.prototype.slice.call(node.attributes, 0)
            .map((n) => n.nodeName)
    },
    getNodeAttrValue (node, attr) {
        return node.getAttribute(attr)
    }
}

module.exports = ASTQAdapterXMLDOM

